/*
 * Capability mapping between tasks.
 *
 * Copyright (C) 2022 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/types.h>

EXTERN_C_BEGIN

struct ipc_mapped_cap
{
  l4_cap_idx_t mapped_cap;
  l4_cap_idx_t cap;
  unsigned char rights;
  l4_umword_t obj_rights;
};

long ipc_map_capability(l4_cap_idx_t task, struct ipc_mapped_cap mapped_cap);

long ipc_map_capabilities(l4_cap_idx_t task, struct ipc_mapped_cap mapped_caps[],
                          unsigned int *count);

EXTERN_C_END

/* vim: tabstop=2 expandtab shiftwidth=2
*/
